using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using System.Data.Odbc;
using System.Security.Cryptography;
using System.Text;

namespace MSGServiceAdmin
{
	/// <summary>
	/// Summary description for WinForm.
	/// </summary>
	public class WinForm : System.Windows.Forms.Form
	{
		/// <summary>
		/// Required designer variable.
		/// </summary>
                private string strHelpFile="";
		private System.ComponentModel.Container components = null;
		private System.Windows.Forms.ComboBox cmbUser;
		private System.Windows.Forms.Button btnUserEdit;
		private System.Windows.Forms.Button btnUserDel;
		private System.Windows.Forms.TextBox txtPassword;
		private System.Windows.Forms.Button btnUserNew;
		private System.Windows.Forms.Button btnUserSave;
		private System.Windows.Forms.Button btnUserCancel;
		private System.Windows.Forms.Label label2;
		private System.Windows.Forms.Button btnStatEdit;
		private System.Windows.Forms.Button btnStatDel;
		private System.Windows.Forms.TextBox txtStatus;
		private System.Windows.Forms.Button btnStatNew;
		private System.Windows.Forms.Button btnStatSave;
		private System.Windows.Forms.Button btnStatCancel;
		private System.Windows.Forms.Label label4;
		private System.Windows.Forms.Button btnOnline;
		private System.Windows.Forms.Button btnMsg;
		private System.Windows.Forms.Button btnFriend;
		private System.Windows.Forms.MainMenu mainMenu1;
		private System.Windows.Forms.MenuItem mnuItmHelp;
		private System.Windows.Forms.MenuItem mnuItm;
		private System.Windows.Forms.ComboBox cmbStatus;
		private System.Windows.Forms.PictureBox pictureBox1;
		private System.Windows.Forms.PictureBox pictureBox2;
		private System.Windows.Forms.TextBox txtPassword2;
		private System.Windows.Forms.Label label1;
		private System.Windows.Forms.TextBox txtUsername;
		private System.Windows.Forms.Label label3;
		private System.Windows.Forms.CheckBox chkStat;
		private System.Windows.Forms.CheckBox chkUser;
		private System.Windows.Forms.Button button1;

		public WinForm()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			//
			// TODO: Add any constructor code after InitializeComponent call
			//
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose (bool disposing)
		{
			if (disposing)
			{
				if (components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose(disposing);
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent() {
			System.Resources.ResourceManager resources = new System.Resources.ResourceManager(typeof(WinForm));
			this.btnOnline = new System.Windows.Forms.Button();
			this.btnMsg = new System.Windows.Forms.Button();
			this.btnFriend = new System.Windows.Forms.Button();
			this.mainMenu1 = new System.Windows.Forms.MainMenu();
			this.mnuItm = new System.Windows.Forms.MenuItem();
			this.mnuItmHelp = new System.Windows.Forms.MenuItem();
			this.pictureBox1 = new System.Windows.Forms.PictureBox();
			this.pictureBox2 = new System.Windows.Forms.PictureBox();
			this.cmbStatus = new System.Windows.Forms.ComboBox();
			this.label4 = new System.Windows.Forms.Label();
			this.btnStatCancel = new System.Windows.Forms.Button();
			this.btnStatSave = new System.Windows.Forms.Button();
			this.btnStatNew = new System.Windows.Forms.Button();
			this.txtStatus = new System.Windows.Forms.TextBox();
			this.btnStatDel = new System.Windows.Forms.Button();
			this.btnStatEdit = new System.Windows.Forms.Button();
			this.label2 = new System.Windows.Forms.Label();
			this.btnUserCancel = new System.Windows.Forms.Button();
			this.btnUserSave = new System.Windows.Forms.Button();
			this.btnUserNew = new System.Windows.Forms.Button();
			this.txtPassword = new System.Windows.Forms.TextBox();
			this.btnUserDel = new System.Windows.Forms.Button();
			this.btnUserEdit = new System.Windows.Forms.Button();
			this.cmbUser = new System.Windows.Forms.ComboBox();
			this.txtPassword2 = new System.Windows.Forms.TextBox();
			this.label1 = new System.Windows.Forms.Label();
			this.txtUsername = new System.Windows.Forms.TextBox();
			this.label3 = new System.Windows.Forms.Label();
			this.chkStat = new System.Windows.Forms.CheckBox();
			this.chkUser = new System.Windows.Forms.CheckBox();
			this.button1 = new System.Windows.Forms.Button();
			this.SuspendLayout();
			// 
			// btnOnline
			// 
			this.btnOnline.Location = new System.Drawing.Point(8, 8);
			this.btnOnline.Name = "btnOnline";
			this.btnOnline.Size = new System.Drawing.Size(88, 40);
			this.btnOnline.TabIndex = 2;
			this.btnOnline.Text = "View  Users";
			this.btnOnline.Click += new System.EventHandler(this.btnOnline_Click);
			// 
			// btnMsg
			// 
			this.btnMsg.Location = new System.Drawing.Point(104, 8);
			this.btnMsg.Name = "btnMsg";
			this.btnMsg.Size = new System.Drawing.Size(88, 40);
			this.btnMsg.TabIndex = 1;
			this.btnMsg.Text = "View Buffered Messages";
			this.btnMsg.Click += new System.EventHandler(this.btnMsg_Click);
			// 
			// btnFriend
			// 
			this.btnFriend.Location = new System.Drawing.Point(216, 8);
			this.btnFriend.Name = "btnFriend";
			this.btnFriend.Size = new System.Drawing.Size(88, 40);
			this.btnFriend.TabIndex = 3;
			this.btnFriend.Text = "View Friends";
			this.btnFriend.Click += new System.EventHandler(this.btnFriend_Click);
			// 
			// mainMenu1
			// 
			this.mainMenu1.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
						this.mnuItm,
						this.mnuItmHelp});
			// 
			// mnuItm
			// 
			this.mnuItm.Index = 0;
			this.mnuItm.Shortcut = System.Windows.Forms.Shortcut.CtrlQ;
			this.mnuItm.Text = "&Exit";
			this.mnuItm.Click += new System.EventHandler(this.menuItem2_Click);
			// 
			// mnuItmHelp
			// 
			this.mnuItmHelp.Index = 1;
			this.mnuItmHelp.Text = "&Help";
			this.mnuItmHelp.Click += new System.EventHandler(this.mnuItmHelp_Click);
			// 
			// pictureBox1
			// 
			this.pictureBox1.BackgroundImage = ((System.Drawing.Image)(resources.GetObject("pictureBox1.BackgroundImage")));
			this.pictureBox1.Location = new System.Drawing.Point(8, 56);
			this.pictureBox1.Name = "pictureBox1";
			this.pictureBox1.Size = new System.Drawing.Size(392, 8);
			this.pictureBox1.TabIndex = 5;
			this.pictureBox1.TabStop = false;
			// 
			// pictureBox2
			// 
			this.pictureBox2.BackgroundImage = ((System.Drawing.Image)(resources.GetObject("pictureBox2.BackgroundImage")));
			this.pictureBox2.Location = new System.Drawing.Point(8, 152);
			this.pictureBox2.Name = "pictureBox2";
			this.pictureBox2.Size = new System.Drawing.Size(392, 8);
			this.pictureBox2.TabIndex = 6;
			this.pictureBox2.TabStop = false;
			// 
			// cmbStatus
			// 
			this.cmbStatus.Location = new System.Drawing.Point(16, 80);
			this.cmbStatus.Name = "cmbStatus";
			this.cmbStatus.Size = new System.Drawing.Size(112, 21);
			this.cmbStatus.TabIndex = 4;
			// 
			// label4
			// 
			this.label4.BackColor = System.Drawing.Color.White;
			this.label4.Image = ((System.Drawing.Image)(resources.GetObject("label4.Image")));
			this.label4.Location = new System.Drawing.Point(24, 112);
			this.label4.Name = "label4";
			this.label4.Size = new System.Drawing.Size(40, 24);
			this.label4.TabIndex = 27;
			this.label4.Text = "Status:";
			this.label4.TextAlign = System.Drawing.ContentAlignment.MiddleRight;
			// 
			// btnStatCancel
			// 
			this.btnStatCancel.Enabled = false;
			this.btnStatCancel.Location = new System.Drawing.Point(296, 112);
			this.btnStatCancel.Name = "btnStatCancel";
			this.btnStatCancel.TabIndex = 10;
			this.btnStatCancel.Text = "Cancel";
			this.btnStatCancel.Click += new System.EventHandler(this.btnStatCancel_Click);
			// 
			// btnStatSave
			// 
			this.btnStatSave.Enabled = false;
			this.btnStatSave.Location = new System.Drawing.Point(216, 112);
			this.btnStatSave.Name = "btnStatSave";
			this.btnStatSave.TabIndex = 9;
			this.btnStatSave.Text = "Save";
			this.btnStatSave.Click += new System.EventHandler(this.btnStatSave_Click);
			// 
			// btnStatNew
			// 
			this.btnStatNew.Location = new System.Drawing.Point(296, 80);
			this.btnStatNew.Name = "btnStatNew";
			this.btnStatNew.TabIndex = 7;
			this.btnStatNew.Text = "New";
			this.btnStatNew.Click += new System.EventHandler(this.btnStatNew_Click);
			// 
			// txtStatus
			// 
			this.txtStatus.Enabled = false;
			this.txtStatus.Location = new System.Drawing.Point(72, 112);
			this.txtStatus.Name = "txtStatus";
			this.txtStatus.Size = new System.Drawing.Size(136, 20);
			this.txtStatus.TabIndex = 8;
			this.txtStatus.Text = "";
			// 
			// btnStatDel
			// 
			this.btnStatDel.Location = new System.Drawing.Point(216, 80);
			this.btnStatDel.Name = "btnStatDel";
			this.btnStatDel.TabIndex = 6;
			this.btnStatDel.Text = "Delete";
			this.btnStatDel.Click += new System.EventHandler(this.btnStatDel_Click);
			// 
			// btnStatEdit
			// 
			this.btnStatEdit.Location = new System.Drawing.Point(136, 80);
			this.btnStatEdit.Name = "btnStatEdit";
			this.btnStatEdit.TabIndex = 5;
			this.btnStatEdit.Text = "Edit";
			this.btnStatEdit.Click += new System.EventHandler(this.btnStatEdit_Click);
			// 
			// label2
			// 
			this.label2.Image = ((System.Drawing.Image)(resources.GetObject("label2.Image")));
			this.label2.Location = new System.Drawing.Point(16, 232);
			this.label2.Name = "label2";
			this.label2.Size = new System.Drawing.Size(64, 24);
			this.label2.TabIndex = 36;
			this.label2.Text = "Password:";
			this.label2.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
			// 
			// btnUserCancel
			// 
			this.btnUserCancel.Enabled = false;
			this.btnUserCancel.Location = new System.Drawing.Point(288, 248);
			this.btnUserCancel.Name = "btnUserCancel";
			this.btnUserCancel.TabIndex = 19;
			this.btnUserCancel.Text = "Cancel";
			this.btnUserCancel.Click += new System.EventHandler(this.btnUserCancel_Click);
			// 
			// btnUserSave
			// 
			this.btnUserSave.Enabled = false;
			this.btnUserSave.Location = new System.Drawing.Point(288, 216);
			this.btnUserSave.Name = "btnUserSave";
			this.btnUserSave.TabIndex = 18;
			this.btnUserSave.Text = "Save";
			this.btnUserSave.Click += new System.EventHandler(this.btnUserSave_Click);
			// 
			// btnUserNew
			// 
			this.btnUserNew.Location = new System.Drawing.Point(296, 176);
			this.btnUserNew.Name = "btnUserNew";
			this.btnUserNew.TabIndex = 14;
			this.btnUserNew.Text = "New";
			this.btnUserNew.Click += new System.EventHandler(this.btnUserNew_Click);
			// 
			// txtPassword
			// 
			this.txtPassword.Enabled = false;
			this.txtPassword.Location = new System.Drawing.Point(128, 232);
			this.txtPassword.Name = "txtPassword";
			this.txtPassword.PasswordChar = '*';
			this.txtPassword.Size = new System.Drawing.Size(136, 20);
			this.txtPassword.TabIndex = 16;
			this.txtPassword.Text = "";
			// 
			// btnUserDel
			// 
			this.btnUserDel.Location = new System.Drawing.Point(216, 176);
			this.btnUserDel.Name = "btnUserDel";
			this.btnUserDel.TabIndex = 13;
			this.btnUserDel.Text = "Delete";
			this.btnUserDel.Click += new System.EventHandler(this.btnUserDel_Click);
			// 
			// btnUserEdit
			// 
			this.btnUserEdit.Location = new System.Drawing.Point(136, 176);
			this.btnUserEdit.Name = "btnUserEdit";
			this.btnUserEdit.TabIndex = 12;
			this.btnUserEdit.Text = "Edit";
			this.btnUserEdit.Click += new System.EventHandler(this.btnUserEdit_Click);
			// 
			// cmbUser
			// 
			this.cmbUser.Location = new System.Drawing.Point(16, 176);
			this.cmbUser.Name = "cmbUser";
			this.cmbUser.Size = new System.Drawing.Size(112, 21);
			this.cmbUser.TabIndex = 11;
			// 
			// txtPassword2
			// 
			this.txtPassword2.Enabled = false;
			this.txtPassword2.Location = new System.Drawing.Point(128, 256);
			this.txtPassword2.Name = "txtPassword2";
			this.txtPassword2.PasswordChar = '*';
			this.txtPassword2.Size = new System.Drawing.Size(136, 20);
			this.txtPassword2.TabIndex = 17;
			this.txtPassword2.Text = "";
			// 
			// label1
			// 
			this.label1.Image = ((System.Drawing.Image)(resources.GetObject("label1.Image")));
			this.label1.Location = new System.Drawing.Point(16, 256);
			this.label1.Name = "label1";
			this.label1.Size = new System.Drawing.Size(112, 24);
			this.label1.TabIndex = 38;
			this.label1.Text = "Re-Enter Password:";
			this.label1.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
			// 
			// txtUsername
			// 
			this.txtUsername.Enabled = false;
			this.txtUsername.Location = new System.Drawing.Point(128, 208);
			this.txtUsername.Name = "txtUsername";
			this.txtUsername.Size = new System.Drawing.Size(136, 20);
			this.txtUsername.TabIndex = 15;
			this.txtUsername.Text = "";
			// 
			// label3
			// 
			this.label3.Image = ((System.Drawing.Image)(resources.GetObject("label3.Image")));
			this.label3.Location = new System.Drawing.Point(16, 208);
			this.label3.Name = "label3";
			this.label3.Size = new System.Drawing.Size(64, 24);
			this.label3.TabIndex = 40;
			this.label3.Text = "Username:";
			this.label3.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
			// 
			// chkStat
			// 
			this.chkStat.Checked = true;
			this.chkStat.CheckState = System.Windows.Forms.CheckState.Indeterminate;
			this.chkStat.Location = new System.Drawing.Point(376, 88);
			this.chkStat.Name = "chkStat";
			this.chkStat.Size = new System.Drawing.Size(24, 24);
			this.chkStat.TabIndex = 41;
			this.chkStat.TabStop = false;
			this.chkStat.Text = "chkStat";
			this.chkStat.ThreeState = true;
			this.chkStat.Visible = false;
			// 
			// chkUser
			// 
			this.chkUser.Checked = true;
			this.chkUser.CheckState = System.Windows.Forms.CheckState.Indeterminate;
			this.chkUser.Location = new System.Drawing.Point(328, 200);
			this.chkUser.Name = "chkUser";
			this.chkUser.Size = new System.Drawing.Size(24, 24);
			this.chkUser.TabIndex = 42;
			this.chkUser.TabStop = false;
			this.chkUser.Text = "chkUser";
			this.chkUser.ThreeState = true;
			this.chkUser.Visible = false;
			// 
			// button1
			// 
			this.button1.Location = new System.Drawing.Point(312, 8);
			this.button1.Name = "button1";
			this.button1.Size = new System.Drawing.Size(88, 40);
			this.button1.TabIndex = 43;
			this.button1.Text = "Server Configuration";
			this.button1.Click += new System.EventHandler(this.button1_Click);
			// 
			// WinForm
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.BackgroundImage = ((System.Drawing.Image)(resources.GetObject("$this.BackgroundImage")));
			this.ClientSize = new System.Drawing.Size(406, 312);
			this.Controls.Add(this.button1);
			this.Controls.Add(this.chkUser);
			this.Controls.Add(this.chkStat);
			this.Controls.Add(this.txtUsername);
			this.Controls.Add(this.txtPassword2);
			this.Controls.Add(this.txtPassword);
			this.Controls.Add(this.txtStatus);
			this.Controls.Add(this.label3);
			this.Controls.Add(this.label1);
			this.Controls.Add(this.label2);
			this.Controls.Add(this.btnUserCancel);
			this.Controls.Add(this.btnUserSave);
			this.Controls.Add(this.btnUserNew);
			this.Controls.Add(this.btnUserDel);
			this.Controls.Add(this.btnUserEdit);
			this.Controls.Add(this.cmbUser);
			this.Controls.Add(this.cmbStatus);
			this.Controls.Add(this.label4);
			this.Controls.Add(this.btnStatCancel);
			this.Controls.Add(this.btnStatSave);
			this.Controls.Add(this.btnStatNew);
			this.Controls.Add(this.btnStatDel);
			this.Controls.Add(this.btnStatEdit);
			this.Controls.Add(this.pictureBox2);
			this.Controls.Add(this.pictureBox1);
			this.Controls.Add(this.btnFriend);
			this.Controls.Add(this.btnMsg);
			this.Controls.Add(this.btnOnline);
			this.FormBorderStyle = System.Windows.Forms.FormBorderStyle.Fixed3D;
			this.Menu = this.mainMenu1;
			this.Name = "WinForm";
			this.Text = "Instant Message Server Admin";
			this.Load += new System.EventHandler(this.WinForm_Load);
			this.ResumeLayout(false);
		}
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new WinForm());
		}

		private void menuItem2_Click(object sender, System.EventArgs e) {
                        this.Close();
		}
		
		private void WinForm_Load(object sender, System.EventArgs e) {
                
                        LoadStatusCombo();
                        LoadUserCombo();

		}



		private void btnStatEdit_Click(object sender, System.EventArgs e) {
                        if (chkStat.CheckState!=CheckState.Indeterminate){
                        	MessageBox.Show("There has been an error. You are trying to do more than one thing at a time.\nPlease finish what you are doing then you can try again.","Error",MessageBoxButtons.OK,MessageBoxIcon.Error);
                                return;
                        }
			txtStatus.Text=(string)cmbStatus.SelectedItem;
                        txtStatus.Enabled=true;
                        btnStatEdit.Enabled=false;
                        btnStatDel.Enabled=false;
                        btnStatNew.Enabled=false;
                        btnStatSave.Enabled=true;
                        btnStatCancel.Enabled=true;
                        btnUserEdit.Enabled=false;
                        btnUserNew.Enabled=false;
                        btnUserDel.Enabled=false;
                        btnMsg.Enabled=false;
                        btnOnline.Enabled=false;
                        btnFriend.Enabled=false;
                        chkStat.CheckState=CheckState.Unchecked;
                        cmbStatus.Enabled=false;
                        cmbUser.Enabled=false;
		}

		private void btnUserEdit_Click(object sender, System.EventArgs e) {
                	if (chkUser.CheckState!=CheckState.Indeterminate){
                        	MessageBox.Show("There has been an error. You are trying to do more than one thing at a time.\nPlease finish what you are doing then you can try again.","Error",MessageBoxButtons.OK,MessageBoxIcon.Error);
                                return;
                        }
                        txtUsername.Enabled=true;
                        txtUsername.ReadOnly=true;
			txtUsername.Text=(string)cmbUser.SelectedItem;
                        txtPassword.Enabled=true;
                        txtPassword2.Enabled=true;
                        btnStatEdit.Enabled=false;
                        btnStatDel.Enabled=false;
                        btnStatNew.Enabled=false;
                        btnUserSave.Enabled=true;
                        btnUserCancel.Enabled=true;
                        btnUserEdit.Enabled=false;
                        btnUserNew.Enabled=false;
                        btnUserDel.Enabled=false;
                        btnMsg.Enabled=false;
                        btnOnline.Enabled=false;
                        btnFriend.Enabled=false;
                        chkUser.CheckState=CheckState.Unchecked;
                        cmbStatus.Enabled=false;
                        cmbUser.Enabled=false;
		}

		private void btnStatDel_Click(object sender, System.EventArgs e) {
                        String name = (string)cmbStatus.SelectedItem;
                        OdbcConnection conn = new OdbcConnection("DSN=Message");
                        if(MessageBox.Show("Are you sure you want to remove this user Status?","Remove Status?",MessageBoxButtons.YesNo,MessageBoxIcon.Question)==DialogResult.Yes){
                        conn.Open();
                        OdbcCommand cmd = new OdbcCommand("DELETE FROM Status WHERE Name = '"+name+"';",conn);
                        cmd.ExecuteNonQuery();
                        conn.Close();
                        MessageBox.Show("Status Option ('"+name+"') has been removed!",name+" removed");
                        LoadStatusCombo();
                        }
		}

		private void btnStatNew_Click(object sender, System.EventArgs e) {
                	if (chkStat.CheckState!=CheckState.Indeterminate){
                        	MessageBox.Show("There has been an error. You are trying to do more than one thing at a time.\nPlease finish what you are doing then you can try again.","Error",MessageBoxButtons.OK,MessageBoxIcon.Error);
                                return;
                        }


                        txtStatus.Enabled=true;
                        btnStatEdit.Enabled=false;
                        btnStatDel.Enabled=false;
                        btnStatNew.Enabled=false;
                        btnStatSave.Enabled=true;
                        btnStatCancel.Enabled=true;
                        btnUserEdit.Enabled=false;
                        btnUserNew.Enabled=false;
                        btnUserDel.Enabled=false;
                        btnMsg.Enabled=false;
                        btnOnline.Enabled=false;
                        btnFriend.Enabled=false;
                        chkStat.CheckState=CheckState.Checked;
                        cmbStatus.Enabled=false;
                        cmbUser.Enabled=false;
		}

		private void btnUserDel_Click(object sender, System.EventArgs e) {
                        String name = (string)cmbUser.SelectedItem;
                        OdbcConnection conn = new OdbcConnection("DSN=Message");
                        conn.Open();
                        OdbcCommand cmd = new OdbcCommand("SELECT User, OtherUser FROM Friend WHERE User='"+name+"' OR OtherUser='"+name+"' UNION  SELECT User, OtherUser FROM FriendReq WHERE User='"+name+"' OR OtherUser='"+name+"';",conn);
                        OdbcDataReader data= cmd.ExecuteReader();


                        if(data.HasRows){
                        	MessageBox.Show("This User has friends, or have requested friends please remove all of these before deleting user.");
                                return;
                        }
                        if (MessageBox.Show("Are you sure you want to remove the user '"+name+"' from the server?","Remove "+name+"?",MessageBoxButtons.YesNo,MessageBoxIcon.Question)==DialogResult.Yes){
                        	cmd = new OdbcCommand("DELETE FROM Authentication WHERE Username = '"+name+"';",conn);
                                cmd.ExecuteNonQuery();

                                MessageBox.Show("The User '"+name+"' has been removed. Although they may be still logged in.\nIf you want you can remove them by selecting them in the 'Manage Online Users' form.","User '"+name+"' removed.'",MessageBoxButtons.OK,MessageBoxIcon.Exclamation);
                                LoadUserCombo();
                        }
                        data.Close();
                        conn.Close();
		}

		private void btnUserNew_Click(object sender, System.EventArgs e) {
			if (chkUser.CheckState!=CheckState.Indeterminate){
                        	MessageBox.Show("There has been an error. You are trying to do more than one thing at a time.\nPlease finish what you are doing then you can try again.","Error",MessageBoxButtons.OK,MessageBoxIcon.Error);
                                return;
                        }
                        txtUsername.Text="";
			txtUsername.ReadOnly=false;
                        txtUsername.Enabled=true;
                        txtPassword.Enabled=true;
                        txtPassword2.Enabled=true;
                        btnStatEdit.Enabled=false;
                        btnStatDel.Enabled=false;
                        btnStatNew.Enabled=false;
                        btnUserSave.Enabled=true;
                        btnUserCancel.Enabled=true;
                        btnUserEdit.Enabled=false;
                        btnUserNew.Enabled=false;
                        btnUserDel.Enabled=false;
                        btnMsg.Enabled=false;
                        btnOnline.Enabled=false;
                        btnFriend.Enabled=false;
                        chkUser.CheckState=CheckState.Checked;
                        cmbStatus.Enabled=false;
                        cmbUser.Enabled=false;
		}

		private void btnUserSave_Click(object sender, System.EventArgs e) {
                        OdbcConnection conn = new OdbcConnection("DSN=Message");
                        OdbcCommand cmd;
                        OdbcDataReader data;
                        ASCIIEncoding ASCII = new ASCIIEncoding();
                        string pass = txtPassword.Text;
                        byte[] bytes=new byte[pass.Length];
                        MD5 enc = new MD5CryptoServiceProvider();
                        bytes = ASCII.GetBytes(pass);
                        bytes = enc.ComputeHash(bytes);
                        pass = ASCII.GetString(bytes);
                        conn.Open();
                        string sql="";
                        switch(chkUser.CheckState){
                        	case CheckState.Checked:
					cmd = new OdbcCommand("SELECT * FROM Authentication WHERE Username='"+txtUsername.Text+"';",conn);
                                        data = cmd.ExecuteReader();
                                        if(data.HasRows){
                                        	MessageBox.Show("User ('"+txtUsername.Text+"') already exist, no changes have been made","User Already Exists.");
                                                return;
                                        }
                                        data.Close();
                                        if(txtPassword.Text!=txtPassword2.Text){
                                        	MessageBox.Show("The two passwords do not match. Please Try Again.","Password Mismatch");
                                                return;
                                        }
                                	sql="INSERT INTO Authentication (Username, Password) VALUES ('"+txtUsername.Text+"','"+pass+"');";
                                        break;
                                case CheckState.Unchecked:
                                	if(txtPassword.Text!=txtPassword2.Text){
                                        	MessageBox.Show("The two passwords do not match. Please Try Again.","Password Mismatch");
                                                return;
                                        }
                                	sql="UPDATE Authentication SET Password='"+pass+"' WHERE Username='"+txtUsername.Text+"';";
                                        break;
                                case CheckState.Indeterminate:
                                         MessageBox.Show("An unknown update of user information was attempted. As a result nothing will be done.");
                                         return;
                        }
                        cmd = new OdbcCommand(sql,conn);
                        try{cmd.ExecuteNonQuery();}
                        catch(InvalidOperationException ioe){
                        MessageBox.Show(ioe.ToString());
                        }

                        conn.Close();
                        MessageBox.Show("The user information has been saved.");
                        LoadUserCombo();
                        btnUserSave.Enabled=false;
                        btnUserCancel.Enabled=false;
                        txtPassword.Enabled=false;
                        txtPassword2.Enabled=false;
                        txtUsername.Enabled=false;
                        btnUserEdit.Enabled=true;
                        btnUserNew.Enabled=true;
                        btnUserDel.Enabled=true;
                        btnStatEdit.Enabled=true;
                        btnStatNew.Enabled=true;
                        btnStatDel.Enabled=true;
                        btnMsg.Enabled=true;
                        btnOnline.Enabled=true;
                        btnFriend.Enabled=true;
                        chkUser.CheckState=CheckState.Indeterminate;
                        cmbStatus.Enabled=true;
                        cmbUser.Enabled=true;
                        txtPassword.Text="";
                        txtPassword2.Text="";
                        txtUsername.Text="";

		}

		private void btnUserCancel_Click(object sender, System.EventArgs e) {
                	btnUserSave.Enabled=false;
                        btnUserCancel.Enabled=false;
                        txtPassword.Enabled=false;
                        txtPassword2.Enabled=false;
                        txtUsername.Enabled=false;
                        btnUserEdit.Enabled=true;
                        btnUserNew.Enabled=true;
                        btnUserDel.Enabled=true;
                        btnStatEdit.Enabled=true;
                        btnStatNew.Enabled=true;
                        btnStatDel.Enabled=true;
                        btnMsg.Enabled=true;
                        btnOnline.Enabled=true;
                        btnFriend.Enabled=true;
                        chkUser.CheckState=CheckState.Indeterminate;
                        cmbStatus.Enabled=true;
                        cmbUser.Enabled=true;
                        txtPassword.Text="";
                        txtPassword2.Text="";
                        txtUsername.Text="";

		}

		private void btnStatSave_Click(object sender, System.EventArgs e) {
			string sql="";
                        switch (chkStat.CheckState){
                        	case CheckState.Checked:
                                	sql="INSERT INTO Status (Name) VALUES('"+txtStatus.Text+"');";
                                        break;
                                case CheckState.Unchecked:
                                	sql="UPDATE Status SET Name='"+txtStatus.Text+"' WHERE Name = '"+cmbStatus.SelectedItem+"';";
                                        break;
                                case CheckState.Indeterminate:
                                	MessageBox.Show("An unknown update of status information was attempted. As a result nothing will be done.");
                        		return;
                        }
                        OdbcConnection conn = new OdbcConnection("DSN=Message");
                        conn.Open();
                        OdbcCommand cmd = new OdbcCommand(sql,conn);
                        int num=cmd.ExecuteNonQuery();
                        conn.Close();
                        MessageBox.Show("The status information has been saved.\n"+sql+"("+num.ToString()+")");
                        LoadStatusCombo();
                        btnStatSave.Enabled=false;
                        btnStatCancel.Enabled=false;
                        txtStatus.Enabled=false;
                        btnUserEdit.Enabled=true;
                        btnUserNew.Enabled=true;
                        btnUserDel.Enabled=true;
                        btnStatEdit.Enabled=true;
                        btnStatNew.Enabled=true;
                        btnStatDel.Enabled=true;
                        btnMsg.Enabled=true;
                        btnOnline.Enabled=true;
                        btnFriend.Enabled=true;
                        chkStat.CheckState=CheckState.Indeterminate;
                        cmbStatus.Enabled=true;
                        cmbUser.Enabled=true;
                        txtStatus.Text="";
		}

		private void btnStatCancel_Click(object sender, System.EventArgs e) {
			btnUserSave.Enabled=false;
                        btnUserCancel.Enabled=false;
                        txtPassword.Enabled=false;
                        txtPassword2.Enabled=false;
                        txtUsername.Enabled=false;
                        btnUserEdit.Enabled=true;
                        btnUserNew.Enabled=true;
                        btnUserDel.Enabled=true;
                        btnStatEdit.Enabled=true;
                        btnStatNew.Enabled=true;
                        btnStatDel.Enabled=true;
                        btnMsg.Enabled=true;
                        btnOnline.Enabled=true;
                        btnFriend.Enabled=true;
                        chkUser.CheckState=CheckState.Indeterminate;
                        cmbStatus.Enabled=true;
                        cmbUser.Enabled=true;
                        txtStatus.Text="";
		}
                private void LoadStatusCombo(){
                	OdbcConnection conn= new OdbcConnection("DSN=Message");
                        conn.Open();
                        OdbcCommand cmd= new OdbcCommand("SELECT * FROM STATUS;",conn);
                        OdbcDataReader data=cmd.ExecuteReader();
                        cmbStatus.Items.Clear();
                        cmbStatus.BeginUpdate();
                        while(data.Read()){
                        	cmbStatus.Items.Add(data.GetString(1));
                	}
                        cmbStatus.EndUpdate();
                        cmbStatus.SelectedIndex=0;
                        data.Close();
                        conn.Close();
                }
                private void LoadUserCombo(){
                        OdbcConnection conn = new OdbcConnection("DSN=Message");
                        OdbcDataReader data;
                        conn.Open();
                	OdbcCommand cmd=new OdbcCommand("SELECT Username FROM Authentication WHERE Username <> 'System';",conn);
                        data=cmd.ExecuteReader();
                        cmbUser.Items.Clear();
                        cmbUser.BeginUpdate();
                        while(data.Read()){
                        	cmbUser.Items.Add(data.GetString(0));
                        }
                        cmbUser.EndUpdate();
                        cmbUser.SelectedIndex=0;
                        data.Close();
                        conn.Close();

                }

		private void btnOnline_Click(object sender, System.EventArgs e) {
			frmOnlineUsers frm=new frmOnlineUsers();
                        frm.ShowDialog();
                        frm=null;
		}

		private void btnFriend_Click(object sender, System.EventArgs e) {
                	WinForm3 frm=new WinForm3();
                        frm.ShowDialog();

		}

		private void btnMsg_Click(object sender, System.EventArgs e) {
                        WinForm2 frm = new WinForm2();
			frm.ShowDialog();
		}
		
		private void button1_Click(object sender, System.EventArgs e) {
			WinForm5 frm = new WinForm5();
                        frm.ShowDialog();
		}

		private void mnuItmHelp_Click(object sender, System.EventArgs e) {
			Help.ShowHelp(this,strHelpFile,HelpNavigator.TableOfContents);
		}
	}
}
